//+------------------------------------------------------------------+
//|                                                    DailyHiLo.mq5 |
//|                                                            Calli |
//|                              https://www.mql5.com/de/users/gooly |
//+------------------------------------------------------------------+
#property copyright "Calli"
#property link      "https://www.mql5.com/de/users/gooly"
#property version   "1.00"
#include <Errors.mqh>
#define _ToStr(A)        #A+"=" + (string)(A)+" " // OK:  Print (TOSTR( __FILE__ ) => __FILE__ = Test5- 2 .mq5


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   2
//--- plot High
#property indicator_label1  "High"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrSilver
#property indicator_style1  STYLE_DOT
#property indicator_width1  1
//--- plot Low
#property indicator_label2  "Low"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrSilver
#property indicator_style2  STYLE_DOT
#property indicator_width2  1
//--- indicator buffers
double         HighBuffer[];
double         LowBuffer[];
int StartBar;
int started = 2;
MqlRates D1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,HighBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,LowBuffer,INDICATOR_DATA);
   StartBar = 3*24*3600/PeriodSeconds(PERIOD_CURRENT) +1;
   int nD1 = CopyRates(_Symbol,PERIOD_D1,0,40,D1);

   
//---
   return(INIT_SUCCEEDED);
  }
  
void OnDeinit(const int re){
   Comment("");
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    // amount of history in bars at the current tick
                const int prev_calculated,// amount of history in bars at the previous tick
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
      ) {
//---
   int nD1 = CopyRates(_Symbol,PERIOD_D1,0,40,D1);
   if (nD1<1) { 
      if (_LastError!=4401) Print(__LINE__,": ",_ToStr(rates_total),_ToStr(prev_calculated),_ToStr(StartBar),_ToStr(nD1),"  ",err(_LastError)); // _LastError!=4401=ERR_HISTORY_NOT_FOUND: Requested history not found

      return(0); 
   }

//---- checking the number of bars to be enough for the calculation
   if(rates_total<StartBar) return(0);
   
//---- Declaration of integer variables
   int first1,bar;

//---- calculation of the starting number 'first' for the cycle of recalculation of bars
   if(prev_calculated==0) // checking for the first start of the indicator calculation
     {
      first1=StartBar; // starting number for calculation of all bars
     }
   else // starting number for calculation of new bars
     {
      first1=prev_calculated-1;
     }
   static datetime newDay = 0;
   for(bar=first1; bar<rates_total; bar++) {
      nD1 = CopyRates(_Symbol,PERIOD_D1,time[bar],2,D1);
      if (nD1<2) continue;
      if ( newDay != D1[0].time ) newDay = D1[0].time;
      HighBuffer[bar] = D1[0].high;
       LowBuffer[bar] = D1[0].low;
   }
   
//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
